#ifndef _VLP_EDITOR_FINDEDIALOG_H
#define _VLP_EDITOR_FINDEDIALOG_H

#include <QtGui/QDialog>
#include <QtCore/QString>


#include "ui/dialogs/FindDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Find Dialog class
 * Displays dialog for finding text in source code
 */
class FindDialog : public QDialog, private Ui::FindDialog {
public:
	/**
	 * Class constructor
	 */
	FindDialog(QWidget * parent = 0);

	/**
	 * Class destuctor
	 */
	~FindDialog();

	/**
	 * Checks if search should be case sensitive
	 * 
	 * @return true if search should be case sensitive, false otherwise
	 */
	bool isCaseSensitive();

	/**
	 * Gets text to search for
	 * 
	 * @return text to search for
	 */
	QString getSearchText();
};

}
}
}

#endif /* _VLP_EDITOR_FINDEDIALOG_H */
