#ifndef _VLP_EDITOR_PROGRAMSTRUCTUREDIALOG_H
#define _VLP_EDITOR_PROGRAMSTRUCTUREDIALOG_H

#include <QtGui/QDialog>
#include <QtCore/QString>


#include "ui/dialogs/ProgramStructureDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Program Structure Dialog class
 * Displays dialog for generating code template for program structure
 */
class ProgramStructureDialog : public QDialog, private Ui::ProgramStructureDialog {
public:
	/**
	 * Class constructor
	 */
	ProgramStructureDialog(QWidget * parent = 0);

	/**
	 * Class destuctor
	 */
	~ProgramStructureDialog();

	/**
	 * Gets user-passed program name
	 * 
	 * @return program name entered in dialog
	 */
	QString getProgramName();

	/**
	 * Gets program code template
	 * 
	 * @return program code template with program name
	 */
	QString getCode();
};

}
}
}

#endif /* _VLP_EDITOR_PROGRAMSTRUCTUREDIALOG_H */
