#ifndef __VLP_CONFIG_H
#define __VLP_CONFIG_H

/**
 * 
 * @author Rafał Długołęcki
 */


#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>

#include <libconfig.h>

namespace loglan {
namespace vlp {

enum ConnectionType {
	EXPLICIT = 1,
	REGISTER = 2
};

/**
 * Common config class used for handling configuration file I/O
 */
class Config
{
private:
	config_t cfg;
	config_setting_t *setting;

	FILE * file;

public:
	Config();
	~Config();

	bool load(const char * configFilePath);
	bool save(const char * configFilePath);

	int getNodeNumber();
	void setNodeNumber(int nodeNumber);

	std::vector<std::string> getHosts();
	void setHosts(std::vector<std::string> hosts);

	ConnectionType getConnectionType();
	void setConnectionType(ConnectionType type);

	const char * getProgramDir();
	void setProgramDir(const char * programDir);
};

}
}

#endif /* __VLP_CONFIG_H */
