/**
 * @file
 */
/**
 * @defgroup IIUWGRAPH
 * @brief Standard class IIUWGRAPH graphics primitives
 */
/** @{ */
/** GRON:procedure(mode:integer) */
#define GRON		100

/** GROFF:procedure */
#define GROFF		101

/** CLS:procedure */
#define CLS		102

/** POINT:procedure(x, y:integer) */
#define POINT		103

/** MOVE:procedure(x, y:integer) */
#define MOVE		104

/** DRAW:procedure(x, y:integer) */
#define DRAW		105

/** HFILL:procedure(x:integer) */
#define HFILL		106

/** VFILL:procedure(y:integer) */
#define VFILL		107

/** COLOR:procedure(color:integer) */
#define COLOR		108

/** STYLE:procedure(style:integer) */
#define STYLE		109

/** PATERN:procedure(p1, p2, p3, p4:integer) */
#define PATERN		110

/** INTENS:procedure(intens:integer) */
#define INTENS		111

/** PALLET:procedure(p:integer) */
#define PALLET		112

/** BORDER:procedure(b:integer) */
#define BORDER		113

/** VIDEO:procedure(buffer:arrayof integer) */
#define VIDEO		114

/** HPAGE:procedure(p, q, r:integer) */
#define HPAGE		115

/** NOCARD:function:integer */
#define NOCARD		116

/** PUSHXY:procedure */
#define PUSHXY		117

/** POPXY:procedure */
#define POPHXY		118

/** INXPOS:function:integer */
#define INXPOS		119

/** INYPOS:function:integer */
#define INYPOS		120

/** INPIX:function(x, y:integer):integer */
#define INPIX		121

/** GETMAP:function(x, y:integer):arrayof integer */
#define GETMAP		122

/** PUTMAP:procedure(arrayof integer) */
#define PUTMAP		123

/** ORMAP:procedure(arrayof integer) */
#define ORMAP		124

/** XORMAP:procedure(arrayof integer) */
#define XORMAP		125

/** TRACK:procedure(x, y:integer) */
#define TRACK		126

/** INKEY:function:integer */
#define INKEY		127

/** HASCII:procedure(ch:integer) */
#define HASCII		128

/** HFONT:procedure(off, seg:integer) */
#define HFONT		129

/** HFONT8:procedure(output off, seg:integer) */
#define HFONT8		130

/** OUTSTRING:procedure(s:string) */
#define OUTSTRING	131

/** CIRB:procedure(x, y, r:integer, alpha, beta:real, b, i, p, q:integer) */
#define CIRB		132	
/** @} */

/**
 * @defgroup MOUSE
 * @brief Standard class MOUSE mouse support
 */
/** @{ */
/** INIT:function(output butttons:integer):boolean */
#define INIT		200

/** SHOWCURSOR:procedure */
#define SHOWCURSOR	201

/** HIDECURSOR:procedure */
#define HIDECURSOR	202

/** STATUS:procedure(output x,y:integer, l,r,c:boolean) */
#define STATUS		203

/** SETPOSITION:procedure(x, y:integer) */
#define SETPOSITION	204

/** GETPRESS:procedure(b:integer; output x,y,p:integer, l, r, c:boolean) */
#define GETPRESS	205

/** GETRELEASE:procedure(b:integer; output x,y,p:integer, l, r, c:boolean) */
#define GETRELEASE	206

/** SETWINDOW:procedure(l, r, t, b:integer) */
#define SETWINDOW	207

/** DEFCURSOR:procedure(select, p, q:integer) */
#define DEFCURSOR	210

/** GETMOVEMENT:procedure(output x, y:integer) */
#define GETMOVEMENT	211

/** SETSPEED:procedure(x, y:integer) */
#define SETSPEED	215

/** SETMARGINS:procedure(l, r, t, b:integer) */
#define SETMARGINS	216

/** SETTHRESHOLD:procedure(t:integer) */
#define SETTHRESHOLD	219
/** @} */
