#include <QtGui/QListWidgetItem>
#include <QtGui/QFileDialog>

#include "AddNodeDialog.h"

namespace loglan {
namespace vlp {
namespace dialog {

AddNodeDialog::AddNodeDialog(QWidget * parent)
	: QDialog(parent)
{
	setupUi(this);

	connectionType->addItem("Explicit");
	connectionType->setCurrentItem(0);
}

AddNodeDialog::~AddNodeDialog()
{
}

int AddNodeDialog::getNodeNumber()
{
	return nodeNumber->value();
}

QString AddNodeDialog::getIPAddress()
{
	return ipAddress->text();
}

QString AddNodeDialog::getConnectionType()
{
	return connectionType->currentText();
}

QString AddNodeDialog::getProgramsDirectory()
{
	return programsDirectory->text();
}

QString AddNodeDialog::getVLPDirectory()
{
	return vlpDirectory->text();
}

void AddNodeDialog::on_programsDirButton_clicked()
{
	QFileDialog dialog(this);
	dialog.setFileMode(QFileDialog::Directory);
	if(dialog.exec()) {
		programsDirectory->setText(dialog.directory().absolutePath() + QDir::separator());
	}
}

void AddNodeDialog::on_vlpDirButton_clicked()
{
	QFileDialog dialog(this);
	dialog.setFileMode(QFileDialog::Directory);
	if(dialog.exec()) {
		vlpDirectory->setText(dialog.directory().absolutePath() + QDir::separator());
	}
}


}
}
}
