#ifndef _VLP_LGCONFIG_ADDNODEDIALOG_H
#define _VLP_LGCONFIG_ADDNODEDIALOG_H

#include <QtGui/QDialog>
#include <QtCore/QString>

#include "ui/dialogs/AddNodeDialog.h"

/**
 * @file
 */

namespace loglan {
namespace vlp {
namespace dialog {

/**
 * Program Unit Dialog class
 * Displays dialog for generating code template for unit structure
 */
class AddNodeDialog : public QDialog, private Ui::AddNodeDialog {
	Q_OBJECT
public:
	/**
	 * Class constructor
	 */
	AddNodeDialog(QWidget * parent = 0);

	/**
	 * Class destuctor
	 */
	~AddNodeDialog();

	/**
	 * Gets user-passed node number
	 *
	 * @return node number entered in dialog
	 */
	int getNodeNumber();

	/**
	 * Gets user-passed ip address
	 *
	 * @return ip address entered in dialog
	 */
	QString getIPAddress();

	/**
	 * Gets user-passed connection type
	 *
	 * @return connection type entered in dialog
	 */
	QString getConnectionType();

	/**
	 * Gets user-passed programs directory
	 *
	 * @return programs directory entered in dialog
	 */
	QString getProgramsDirectory();

	/**
	 * Gets user-passed VLP directory
	 *
	 * @return VLP directory entered in dialog
	 */
	QString getVLPDirectory();

private slots:
	void on_programsDirButton_clicked();
	void on_vlpDirButton_clicked();
};

}
}
}

#endif /* _VLP_EDITOR_PROGRAMSTRUCTUREDIALOG_H */
