#include <QtGui/QApplication>
#include <QtCore/QList>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <libconfig.h>

#include "lgconfig.h"
#include "NodeListDialog.h"
#include "vlp/config.h"

namespace loglan {
namespace vlp {

QInstall::QInstall()
{
	setupUi(this);
}

void QInstall::on_actionConfigure_triggered()
{
	dialog::NodeListDialog dialog(nodes, this);

	if (dialog.exec()) {
		nodes = dialog.getNodes();

		if (!nodes.isEmpty()) {

			VLPEntry *pom;
			int i;
			char pomstr[255];

			QListIterator<VLPEntry *> nodesIterator(nodes);

			while (nodesIterator.hasNext()) {
				pom = nodesIterator.next();
				i = nodes.indexOf(pom);
				sprintf(pomstr, "%s.cfg", pom->addr);

				
				loglan::vlp::Config config;

				config.setProgramDir(pom->progdir);
				config.setNodeNumber(pom->ID);
				config.setConnectionType(
					(pom->type == 0) ? EXPLICIT : REGISTER
				);

				std::vector<std::string> hosts;
				for (auto node : nodes) {
					if (pom != node) {
						hosts.push_back(node->addr);
					}
				}
				config.setHosts(hosts);

				config.save(pomstr);

// TODO: add handling of homedir or remove it at all
// 				setting = config_setting_get_member(root, "homedir");
// 				if(!setting) {
// 					setting = config_setting_add(root, "homedir", CONFIG_TYPE_STRING);
// 				}
// 				config_setting_set_string(setting, pom->homedir);


				pom = nodes.at(i);
			}
		}
	}
}


void QInstall::on_actionQuit_triggered()
{
	QApplication::instance()->quit();
}

}
}


int main(int argc, char **argv)
{
	QApplication *app = new QApplication(argc,argv);
	loglan::vlp::QInstall cfg;
	cfg.show();
	return app->exec();
}
