#include <QtCore/QList>
#include <QtCore/QString>
#include <stdio.h>
#include <QtCore/qfile.h>
#include <QtCore/QTextStream>
#include <string.h>
#include <QtCore/QDir>
#include <unistd.h>

class IncFile
{
public:
	char filename[255];
	int start, len;
	IncFile(char *s, int st)
	{
		strcpy(filename,s);
		start=st;
		len=0;
	};
};

QList<IncFile*> inc;

IncFile *findTrueLine(int ln, int *trueline)
{
	IncFile *pom;
	IncFile *pom1;
	QList<IncFile*> pl;
	int c1 = 0;
// 	int c2 = 0;

	QListIterator<IncFile*> incFileIterator(inc);
	if (!incFileIterator.hasNext()) {
		*trueline = ln;
		return NULL;
	}
	pl.clear();
	pom = incFileIterator.next();
	if (pom->start > ln) {
		*trueline = ln;
		return NULL;
	}

	while ((incFileIterator.hasNext()) && (ln > pom->start)) {
		if (ln < pom->start + pom->len) {
			*trueline = ln-pom->start;
			return pom;
		}
		pl.append(pom);
		pom=incFileIterator.next();
	}

	if (incFileIterator.hasNext()) {
		QListIterator<IncFile*> plIterator(pl);
		c1=0;
		while (plIterator.hasNext()) {
			pom1 = plIterator.next();
			c1 += pom1->len;
		}
		*trueline = ln - c1;
		return NULL;
	} else {
		incFileIterator.toFront();
		c1 = 0;
		while (incFileIterator.hasNext()) {
			pom1 = incFileIterator.next();
			c1 += pom1->len;
		}
		*trueline = ln - c1;
		return NULL;
	}
	return NULL;
}

int main(int argc,char **argv)
{
	char homedir[255];
	char mydir[255];
	char ss[255];
	char fname[255];
	QString poms, poms1, poms2;

	int currentline = 1;
	int i, j, line, tline;

	inc.clear();
	poms.sprintf("%s", argv[1]);
	i = poms.findRev('/', poms.length() - 1, FALSE);

	//******* get home directory
	if (i != -1) {
		poms1 = poms.left(i + 1);
		strcpy(homedir, poms1.toStdString().c_str());
	}
	else
		strcpy(homedir, "");

	poms.sprintf("%s", argv[0]);
	i = poms.findRev('/', poms.length() - 1, FALSE);
	if (i != -1) {
		poms1=poms.left(i);
	}
	else
		poms1.sprintf(".");

	strcpy(mydir, poms1.toStdString().c_str());

	poms.sprintf("%s", argv[1]);
	i = poms.findRev(".log", poms.length()-1, FALSE);
	poms1 = poms.left(i);
	strcpy(fname, poms1.toStdString().c_str());

	// ********************

	poms.sprintf("%s/.cmp00", mydir);
	poms1.sprintf("%s/cmp01.log", mydir);
	unlink(poms.toStdString().c_str());
	unlink(poms1.toStdString().c_str());

	QFile compfile(poms1);
	QFile srcfile(argv[1]);

	if (!compfile.open(IO_WriteOnly)) {
		fprintf(stdout,"Cannot open temp file to write %s\n", poms1.toStdString().c_str());
		exit(1);
	}

	if (!srcfile.open(IO_ReadOnly)) {
		fprintf(stdout, "Cannot open file: %s\n", srcfile.fileName().toStdString().c_str());
		exit(1);
	}

	QTextStream comps(&compfile);
	QTextStream src(&srcfile);

	while (!src.atEnd()) {
		poms = src.readLine();
		i = poms.find("#include");
		if (i != -1) {
			/* get include file */
			i=poms.find('"');
			if (i != -1) {
				j=poms.find('"',i+1);
			}
			if ((i != -1) && (j != -1)) {
				IncFile *p;
				poms1 = poms.mid(i + 1, j - i - 1);
				p = new IncFile((char*)poms1.ascii(),
								currentline);
				poms2.sprintf("%s%s", homedir, poms1.toStdString().c_str());
				QFile pomf(poms2.toStdString().c_str());
				if (!pomf.open(IO_ReadOnly)) {
					fprintf(stdout, "Cannot open include "
						"file: %s\n", poms2.toStdString().c_str());
					exit(1);
				}
				QTextStream pomstream(&pomf);
				while (!pomstream.atEnd()) {
					poms1 = pomstream.readLine();
					comps << poms1.toStdString().c_str();
					comps << "\n";
					p->len++;
					currentline++;
				}
				pomf.close();
				inc.append(p);
			}
		} else {
			comps << poms.toStdString().c_str();
			comps << "\n";
		}
		currentline++;
	}/* eof */

	srcfile.close();
	compfile.close();

	poms.sprintf("%s/cmp01.lcd", mydir);
	unlink(poms.toStdString().c_str());

	sprintf(ss, "%s/loglan %s/cmp01 > %s/.cmp00", mydir, mydir, mydir);
	if (system(ss) == -1) {
		fprintf(stdout, "Cannot execute compiler\n");
		exit(1);
	}

	poms1.sprintf("%s.lcd", fname);

	if (QFile::exists(poms.toStdString().c_str())) {
		rename(poms.toStdString().c_str(), poms1.toStdString().c_str());
		unlink(poms.toStdString().c_str());
		fprintf(stdout, "Compile ok\n");
		sprintf(ss,"%s/gen %s", mydir, fname);
		if (system(ss)==-1) {
			fprintf(stdout, "Cannot execute generator\n");
			exit(1);
		}
		poms.sprintf("%s.ccd", fname);
		if (QFile::exists(poms.toStdString().c_str())) {
			unlink(poms1.toStdString().c_str());
		}
	} else {
		QString errors;
		errors.sprintf("Errors: %s does not exists, current path: %s\n",
			poms.toStdString().c_str(),
			QDir::currentPath().toStdString().c_str()
		);
		fprintf(stdout, errors.toStdString().c_str());
		poms.sprintf("%s/.cmp00", mydir);
		QFile err(poms.toStdString().c_str());

		if (!err.open(IO_ReadOnly)) {
			fprintf(stdout,"Cannot open error file\n");
			exit(1);
		}
		QTextStream errstream(&err);
		IncFile *fl;

		poms = errstream.readLine();
		i = poms.find("LOGLAN-82");
		while ((!errstream.atEnd()) && (i == -1)) {
			poms = errstream.readLine();
			i = poms.find("LOGLAN-82");
		}

		while (!errstream.atEnd()) {
			poms = errstream.readLine();
			i = poms.find("ERROR");
			if (i != -1) {
				i = i-2;
				j = poms.findRev(' ', i);
				poms1 = poms.mid(j + 1, i - j);
				line = poms1.toInt();
				fl = findTrueLine(line, &tline);
				poms2 = poms.right(poms.length() - i - 1);
				if (fl != NULL)
					fprintf(stdout, "%s: ", fl->filename);
				fprintf(stdout, "%d  %s\n",
							tline, poms2.toStdString().c_str());
			}
		}
		err.close();
	} /* errors */

	poms.sprintf("%s/cmp01.log",mydir);
	unlink(poms.toStdString().c_str());
	poms.sprintf("%s/.cmp00",mydir);
	unlink(poms.toStdString().c_str());

	return 0;
}
